/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	DBアクセスクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo;

import java.sql.*;
import jp.co.ntt.lms.xmo.util.*;

/**
 * DBコネクションを使用するクラスです。<BR>
 * DBConnectorクラスからコネクションを借り、SQLの実行を行い、<BR>
 * コネクションの返却処理を行います
 * 各XMOのDataAccess機能はこのクラス使用してコネクションを取得してください。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004.01.08
 */
public class DataAccessHandler {

	/**
	 * コネクション操作クラスを保持します
	 */
	private ConnectionHandler mobjConHandler;

	/**
	 * コネクションを保持します
	 */
	private Connection con;

	/**
	 * ステートメントを保持します
	 */
	private Statement statement;

	/**
	 * CollableStatementを保持します
	 */
	private CallableStatement cbstatement;

	/**
	 * PreparedStatementを保持します
	 */
	private PreparedStatement prstatement;

	/**
	 * 結果セットを保持します
	 */
	private ResultSet resultSet;

	/**
	 * コンストラクタです
	 */
	public DataAccessHandler()
		throws SQLException
	{
		init();
	}

	/**
	 * コンストラクタです。
	 * DB接続情報を受け取り、DB接続を保持します
	 * @param strDriver DBドライバー
	 * @param strConStr DB接続文字列
	 * @param strUser   DBユーザ
	 * @param strPass   DBパスワード
	 */
	public DataAccessHandler(	String strDriver,
								String strConStr,
								String strUser,
								String strPass	)
		throws SQLException, ClassNotFoundException
	{
		mobjConHandler = new ConnectionHandler(	strDriver,
												strConStr,
												strUser,
												strPass	);

		con = mobjConHandler.getConnection();
		statement = con.createStatement();
	}

	/**
	 * 初期化処理<BR>
	 * コネクションプールからコネクションを取得します
	 */
	private void init()
		throws SQLException
	{
		mobjConHandler = DBConnector.getInstance().getConnection();
		con = mobjConHandler.getConnection();

		// ステートメントの作成
		try {
			statement = con.createStatement();
		}
		catch( SQLException se ) {
			// 例外が発生した場合、プールされたコネクションが切断している可能性がある。
			// DBの再起動を行ったときなど。
			// そのため、もう再接続処理を行う。
			mobjConHandler.reConnect();
			statement = con.createStatement();
		}
	}

	/**
	 * 終了処理
	 */
	private void terminate()
		throws SQLException
	{
		// ステートメントとリザルトセットが存在した場合
		// クローズ処理を行う
		try {
			close();
			// コネクション返却処理
			returnConnection();
		}
		catch( SQLException e ) {
			// クローズ処理でエラーが起きても何もしない
		}
	}

	/**
	 * 指定されたSQLでCollableStatementを作成して返します
	 */
	public CallableStatement prepareCall( String strSQL )
		throws SQLException
	{
		close();
		cbstatement = con.prepareCall( strSQL );
		return cbstatement;
	}

	/**
	 * 指定されたSQLでPreparedStatementを作成して返します
	 */
	public PreparedStatement prepareStatement( String strSQL )
		throws SQLException
	{
		close();
		prstatement = con.prepareStatement( strSQL );
		return prstatement;
	}

	/**
	 * クエリーを実行します
	 * @param strSQL	実行するSQL文
	 * @return ResultSet 結果セット
	 */
	public ResultSet executeQuery( String strSQL )
		throws SQLException
	{
DebugLog.write( this.getClass(), "検索実行::::: " + strSQL, DebugLog.ROW );
		close();
		
		statement = con.createStatement();	
		resultSet = statement.executeQuery(strSQL);
		return resultSet;
	}

	/**
	 * SQLを実行します
	 * @param strSQL	実行するSQL文
	 */
	public void execute( String strSQL )
		throws SQLException
	{
DebugLog.write( this.getClass(), "SQL実行::::: " + strSQL, DebugLog.ROW );
		close();
		
		statement = con.createStatement();	
		statement.execute(strSQL);
	}

	/**
	 * コミットを行います
	 */
	public void commit()
		throws SQLException
	{
		con.commit();
DebugLog.write( this.getClass(), "コミット::::: " + mobjConHandler.getIndex(), DebugLog.ROW );
		terminate();
	}

	/**
	 * ロールバックを行います
	 */
	public void rollback()
		throws SQLException
	{
		con.rollback();
DebugLog.write( this.getClass(), "ロールバック::::: " + mobjConHandler.getIndex(), DebugLog.ROW );
		terminate();
	}

	/**
	 * 現在保持しているコネクション操作クラスのインデックスを取得します
	 * @return int インデックス
	 */
	public int getConnectionIndex() {
		return mobjConHandler.getIndex();
	}

	/**
	 * ステートメントとリザルトセットが存在した場合クローズ処理を行います
	 */
	public void close()
		throws SQLException
	{
		if( resultSet != null ) {
			resultSet.close();
			resultSet = null;
		}
		if( statement != null ) {
			statement.close();
			statement = null;
		}
		if( cbstatement != null ) {
			cbstatement.close();
			cbstatement = null;
		}
		if( prstatement != null ) {
			prstatement.close();
			prstatement = null;
		}
	}
	
	/**
	 * コネクション返却処理
	 */
	private void returnConnection() 
		throws SQLException
	{
		// 現在保持しているコネクションがプールから取得されたものでない場合
		// (コネクションインデックスがデフォルトの-1の場合)
		if( mobjConHandler.getIndex() < 0 ) {
			mobjConHandler.getConnection().close();
		}
		else {
			// DBコネクションを返却します
			DBConnector.getInstance().returnConnection(mobjConHandler);
			mobjConHandler = null;
		}
	}
}


